#! /bin/sh

# Script to test fragmentation code.

# Need job control.
set -m

# More than about 10 hits queue limits 8-(
FRAGSIZE=1480
TOTAL_FRAGS=10
TOTAL_SIZE=`expr $TOTAL_FRAGS \* $FRAGSIZE + 20`

# Generate giant fragmentogram (backwards!)
../tools/rcv_ip 30 `expr $TOTAL_FRAGS + 1` < /dev/tap1 > $TMPFILE &
sleep 1

i=`expr $TOTAL_FRAGS \* $FRAGSIZE`
MF=""
while [ $i -ge 0 ]
do
    ../tools/gen_ip FRAG=$i,$FRAGSIZE $MF $TAP0NET.2 $TAP1NET.2 $TOTAL_SIZE 17 1 2 > /dev/tap0 || exit 1
    i=`expr $i - $FRAGSIZE`
    MF="MF"
done

if wait %../tools/rcv_ip; then :
else
    echo wait failed
    cat $TMPFILE
    exit 1
fi

# We expect a series of forward fragments.
if [ "`cat $TMPFILE`" != "MF $TAP0NET.2 $TAP1NET.2 `expr $FRAGSIZE + 20` 17 1 2 
FRAG=`expr $FRAGSIZE \* 1` MF $TAP0NET.2 $TAP1NET.2 `expr $FRAGSIZE + 20` 17 
FRAG=`expr $FRAGSIZE \* 2` MF $TAP0NET.2 $TAP1NET.2 `expr $FRAGSIZE + 20` 17 
FRAG=`expr $FRAGSIZE \* 3` MF $TAP0NET.2 $TAP1NET.2 `expr $FRAGSIZE + 20` 17 
FRAG=`expr $FRAGSIZE \* 4` MF $TAP0NET.2 $TAP1NET.2 `expr $FRAGSIZE + 20` 17 
FRAG=`expr $FRAGSIZE \* 5` MF $TAP0NET.2 $TAP1NET.2 `expr $FRAGSIZE + 20` 17 
FRAG=`expr $FRAGSIZE \* 6` MF $TAP0NET.2 $TAP1NET.2 `expr $FRAGSIZE + 20` 17 
FRAG=`expr $FRAGSIZE \* 7` MF $TAP0NET.2 $TAP1NET.2 `expr $FRAGSIZE + 20` 17 
FRAG=`expr $FRAGSIZE \* 8` MF $TAP0NET.2 $TAP1NET.2 `expr $FRAGSIZE + 20` 17 
FRAG=`expr $FRAGSIZE \* 9` MF $TAP0NET.2 $TAP1NET.2 `expr $FRAGSIZE + 20` 17 
FRAG=`expr $FRAGSIZE \* 10` $TAP0NET.2 $TAP1NET.2 `expr $FRAGSIZE + 20` 17 " ]
then
    echo "Unexpected fragments: "
    cat $TMPFILE
    exit 1
fi

exit 0
